// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S220_HtmlDebugRenderer.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;


@SuppressWarnings("fallthrough")
class S220_HtmlDebugRenderer extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0, 0
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\37\u0200\1\u0300\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\12\0\1\1\2\0\1\1\24\0\1\1\14\0\1\2"+
    "\12\3\1\4\6\0\1\5\1\6\1\7\1\10\1\11"+
    "\1\12\1\13\1\14\1\15\1\16\1\17\1\20\1\21"+
    "\1\22\1\23\1\24\1\25\1\26\1\27\1\30\1\31"+
    "\1\32\1\33\1\25\1\34\1\25\1\35\1\0\1\36"+
    "\1\0\1\37\1\0\1\40\1\41\1\42\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\54"+
    "\1\55\1\56\1\57\1\0\1\60\1\61\1\62\1\63"+
    "\1\64\1\65\1\0\1\66\266\0\2\50\115\0\1\61"+
    "\u01aa\0\1\52\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1024];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\1\0\1\1\1\2\1\1\10\0\1\3\u014e\0\1\3"+
    "\13\0\1\3\17\0\1\3\16\0\1\3\100\0\1\3"+
    "\3\0\1\3\15\0\1\3\1\0\1\3\11\0\1\3"+
    "\1\0\1\3\10\0\1\3\11\0\1\3\17\0\1\4"+
    "\4\0\1\5\1\0\1\3\4\0\1\6\3\0\1\7"+
    "\23\0\1\10\1\0\1\11\3\0\1\12\1\13\2\0"+
    "\1\14\1\15\1\0\1\16\1\0\1\17\1\0\1\20";

  private static int [] zzUnpackAction() {
    int [] result = new int[576];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\67\0\156\0\245\0\334\0\u0113\0\u014a\0\u0181"+
    "\0\u01b8\0\u01ef\0\u0226\0\u025d\0\67\0\u0294\0\u02cb\0\u0302"+
    "\0\u0339\0\u0370\0\u03a7\0\u03de\0\u0415\0\u044c\0\u0483\0\u04ba"+
    "\0\u04f1\0\u0528\0\u055f\0\u0596\0\u05cd\0\u0604\0\u063b\0\u0672"+
    "\0\u06a9\0\u06e0\0\u0717\0\u074e\0\u0785\0\u07bc\0\u07f3\0\u082a"+
    "\0\u0861\0\u0898\0\u08cf\0\u0906\0\u093d\0\u0974\0\u09ab\0\u09e2"+
    "\0\u0a19\0\u0a50\0\u0a87\0\u0abe\0\u0af5\0\u0b2c\0\u0b63\0\u0b9a"+
    "\0\u0bd1\0\u0c08\0\u0c3f\0\u0c76\0\u0cad\0\u0ce4\0\u0d1b\0\u0d52"+
    "\0\u0d89\0\u0dc0\0\u0df7\0\u0e2e\0\u0e65\0\u0e9c\0\u0ed3\0\u0f0a"+
    "\0\u0f41\0\u0f78\0\u0faf\0\u0fe6\0\u101d\0\u1054\0\u108b\0\u10c2"+
    "\0\u10f9\0\u1130\0\u1167\0\u119e\0\u11d5\0\u120c\0\u1243\0\u127a"+
    "\0\u12b1\0\u12e8\0\u131f\0\u1356\0\u138d\0\u13c4\0\u13fb\0\u1432"+
    "\0\u1469\0\u14a0\0\u14d7\0\u150e\0\u1545\0\u157c\0\u15b3\0\u15ea"+
    "\0\u1621\0\u1658\0\u168f\0\u16c6\0\u16fd\0\u1734\0\u176b\0\u17a2"+
    "\0\u17d9\0\u1810\0\u1847\0\u187e\0\u18b5\0\u18ec\0\u1923\0\u195a"+
    "\0\u1991\0\u19c8\0\u19ff\0\u1a36\0\u1a6d\0\u1aa4\0\u1adb\0\u1b12"+
    "\0\u1b49\0\u1b80\0\u1bb7\0\u1bee\0\u1c25\0\u1c5c\0\u1c93\0\u1cca"+
    "\0\u1d01\0\u1d38\0\u1d6f\0\u1da6\0\u1ddd\0\u1e14\0\u1e4b\0\u1e82"+
    "\0\u1eb9\0\u1ef0\0\u1f27\0\u1f5e\0\u1f95\0\u1fcc\0\u2003\0\u203a"+
    "\0\u2071\0\u20a8\0\u20df\0\u2116\0\u214d\0\u2184\0\u21bb\0\u21f2"+
    "\0\u2229\0\u2260\0\u2297\0\u22ce\0\u2305\0\u233c\0\u2373\0\u23aa"+
    "\0\u23e1\0\u2418\0\u244f\0\u2486\0\u24bd\0\u24f4\0\u252b\0\u2562"+
    "\0\u2599\0\u25d0\0\u2607\0\u263e\0\u2675\0\u26ac\0\u26e3\0\u271a"+
    "\0\u2751\0\u2788\0\u27bf\0\u27f6\0\u282d\0\u2864\0\u289b\0\u28d2"+
    "\0\u2909\0\u2940\0\u2977\0\u29ae\0\u29e5\0\u2a1c\0\u2a53\0\u2a8a"+
    "\0\u2ac1\0\u2af8\0\u2b2f\0\u2b66\0\u2b9d\0\u2bd4\0\u2c0b\0\u2c42"+
    "\0\u2c79\0\u2cb0\0\u2ce7\0\u2d1e\0\u2d55\0\u2d8c\0\u2dc3\0\u2dfa"+
    "\0\u2e31\0\u2e68\0\u2e9f\0\u2ed6\0\u2f0d\0\u2f44\0\u2f7b\0\u2fb2"+
    "\0\u2fe9\0\u3020\0\u3057\0\u308e\0\u30c5\0\u30fc\0\u3133\0\u316a"+
    "\0\u31a1\0\u31d8\0\u320f\0\u3246\0\u327d\0\u32b4\0\u32eb\0\u3322"+
    "\0\u3359\0\u3390\0\u33c7\0\u33fe\0\u3435\0\u346c\0\u34a3\0\u34da"+
    "\0\u3511\0\u3548\0\u357f\0\u35b6\0\u35ed\0\u3624\0\u365b\0\u3692"+
    "\0\u36c9\0\u3700\0\u3737\0\u376e\0\u37a5\0\u37dc\0\u3813\0\u384a"+
    "\0\u3881\0\u38b8\0\u38ef\0\u3926\0\u395d\0\u3994\0\u39cb\0\u3a02"+
    "\0\u3a39\0\u3a70\0\u3aa7\0\u3ade\0\u3b15\0\u3b4c\0\u3b83\0\u3bba"+
    "\0\u3bf1\0\u3c28\0\u3c5f\0\u3c96\0\u3ccd\0\u3d04\0\u3d3b\0\u3d72"+
    "\0\u3da9\0\u3de0\0\u3e17\0\u3e4e\0\u3e85\0\u3ebc\0\u3ef3\0\u3f2a"+
    "\0\u3f61\0\u3f98\0\u3fcf\0\u4006\0\u403d\0\u4074\0\u40ab\0\u40e2"+
    "\0\u4119\0\u4150\0\u4187\0\u41be\0\u41f5\0\u422c\0\u4263\0\u429a"+
    "\0\u42d1\0\u4308\0\u433f\0\u4376\0\u43ad\0\u43e4\0\u441b\0\u4452"+
    "\0\u4489\0\u44c0\0\u44f7\0\u452e\0\u4565\0\u459c\0\u45d3\0\u460a"+
    "\0\u4641\0\u4678\0\u46af\0\u46e6\0\u471d\0\u4754\0\u478b\0\u47c2"+
    "\0\u47f9\0\u4830\0\u4867\0\u489e\0\u48d5\0\u490c\0\u4943\0\u497a"+
    "\0\u49b1\0\u49e8\0\u4a1f\0\u4a56\0\u4a56\0\u4a8d\0\u4ac4\0\u4afb"+
    "\0\u4b32\0\u4b69\0\u4ba0\0\u4bd7\0\u4c0e\0\u4c45\0\u4c7c\0\u4cb3"+
    "\0\u4cb3\0\u4cea\0\u4d21\0\u4d58\0\u4d8f\0\u4dc6\0\u4dfd\0\u4e34"+
    "\0\u4e6b\0\u4ea2\0\u4ed9\0\u4f10\0\u4f47\0\u4f7e\0\u4fb5\0\u4fec"+
    "\0\u4fec\0\u5023\0\u505a\0\u5091\0\u50c8\0\u50ff\0\u5136\0\u516d"+
    "\0\u51a4\0\u51db\0\u5212\0\u5249\0\u5280\0\u52b7\0\u52ee\0\u52ee"+
    "\0\u5325\0\u535c\0\u5393\0\u53ca\0\u5401\0\u5438\0\u546f\0\u54a6"+
    "\0\u54dd\0\u5514\0\u554b\0\u5582\0\u55b9\0\u55f0\0\u5627\0\u565e"+
    "\0\u5695\0\u56cc\0\u5703\0\u573a\0\u5771\0\u57a8\0\u57df\0\u5816"+
    "\0\u584d\0\u5884\0\u58bb\0\u58f2\0\u5929\0\u5960\0\u5997\0\u59ce"+
    "\0\u5a05\0\u5a3c\0\u5a73\0\u5aaa\0\u5ae1\0\u5b18\0\u5b4f\0\u5b86"+
    "\0\u5bbd\0\u5bf4\0\u5c2b\0\u5c62\0\u5c99\0\u5cd0\0\u5d07\0\u5d3e"+
    "\0\u5d75\0\u5dac\0\u5de3\0\u5e1a\0\u5e51\0\u5e88\0\u5ebf\0\u5ef6"+
    "\0\u5f2d\0\u5f64\0\u5f9b\0\u5fd2\0\u6009\0\u6040\0\u6077\0\u60ae"+
    "\0\u60ae\0\u60e5\0\u611c\0\u6153\0\u6153\0\u618a\0\u61c1\0\u61f8"+
    "\0\u622f\0\u6266\0\u629d\0\u62d4\0\u630b\0\u6342\0\u6379\0\u63b0"+
    "\0\u63e7\0\u641e\0\u641e\0\u6455\0\u6455\0\u648c\0\u64c3\0\u64fa"+
    "\0\u6531\0\u6568\0\u659f\0\u65d6\0\u660d\0\u6644\0\u6644\0\u667b"+
    "\0\u667b\0\u66b2\0\u66e9\0\u6720\0\u6757\0\u678e\0\u67c5\0\u67fc"+
    "\0\u6833\0\u6833\0\u686a\0\u68a1\0\u68d8\0\u690f\0\u6946\0\u697d"+
    "\0\u69b4\0\u69eb\0\u6a22\0\u6a22\0\u6a59\0\u6a90\0\u6ac7\0\u6afe"+
    "\0\u6b35\0\u6b6c\0\u6ba3\0\u6bda\0\u6c11\0\u6c48\0\u6c7f\0\u6cb6"+
    "\0\u6ced\0\u6d24\0\67\0\u6d5b\0\u6d92\0\u6dc9\0\u6e00\0\67"+
    "\0\u6e37\0\u6e6e\0\u6e6e\0\u6ea5\0\u6edc\0\u6f13\0\67\0\u6f4a"+
    "\0\u6f81\0\u6fb8\0\67\0\u6fef\0\u7026\0\u705d\0\u7094\0\u70cb"+
    "\0\u7102\0\u7139\0\u7170\0\u71a7\0\u71de\0\u7215\0\u724c\0\u7283"+
    "\0\u72ba\0\u72f1\0\u7328\0\u735f\0\u7396\0\u73cd\0\67\0\u7404"+
    "\0\67\0\u743b\0\u7472\0\u74a9\0\67\0\67\0\u74e0\0\u7517"+
    "\0\67\0\67\0\u754e\0\67\0\u7585\0\67\0\u75bc\0\67";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[576];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\3\2\1\3\31\2\1\4\31\2\72\0\1\3\65\0"+
    "\1\5\15\0\1\6\32\0\1\6\33\0\1\7\32\0"+
    "\1\7\32\0\1\10\32\0\1\10\33\0\1\11\32\0"+
    "\1\11\36\0\1\12\32\0\1\12\33\0\1\13\32\0"+
    "\1\13\15\0\1\14\120\0\1\15\35\0\1\16\1\17"+
    "\1\20\1\21\1\22\1\23\5\17\1\24\1\25\1\26"+
    "\1\27\1\30\1\17\1\31\1\32\3\17\1\33\1\34"+
    "\2\0\1\17\1\35\1\0\1\36\1\37\1\40\1\41"+
    "\5\0\1\42\1\43\1\44\1\45\1\46\1\47\1\50"+
    "\3\0\1\51\1\52\4\0\1\53\17\17\1\54\10\17"+
    "\2\0\1\17\17\0\1\55\13\0\1\53\30\17\2\0"+
    "\1\17\33\0\1\53\1\56\7\17\1\57\2\17\1\60"+
    "\2\17\1\61\11\17\2\0\1\17\1\62\7\0\1\63"+
    "\2\0\1\64\2\0\1\65\14\0\1\53\4\17\1\66"+
    "\11\17\1\67\11\17\2\0\1\17\4\0\1\70\11\0"+
    "\1\71\14\0\1\53\24\17\1\72\3\17\2\0\1\17"+
    "\23\0\1\73\7\0\1\53\24\17\1\74\3\17\2\0"+
    "\1\17\23\0\1\75\7\0\1\53\4\17\1\76\23\17"+
    "\2\0\1\17\4\0\1\77\26\0\1\53\10\17\1\100"+
    "\13\17\1\101\3\17\2\0\1\17\10\0\1\102\12\0"+
    "\1\103\7\0\1\53\1\104\15\17\1\105\5\17\1\106"+
    "\3\17\2\0\1\17\1\107\15\0\1\110\4\0\1\111"+
    "\7\0\1\53\23\17\1\112\4\17\2\0\1\17\22\0"+
    "\1\113\10\0\1\53\1\114\23\17\1\115\3\17\2\0"+
    "\1\17\1\116\22\0\1\117\7\0\1\53\4\17\1\120"+
    "\20\17\1\121\2\17\2\0\1\17\4\0\1\122\17\0"+
    "\1\123\6\0\1\53\23\17\1\124\1\125\3\17\2\0"+
    "\1\17\22\0\1\126\1\127\7\0\1\53\1\130\27\17"+
    "\2\0\1\17\1\131\32\0\1\53\4\17\1\132\23\17"+
    "\2\0\1\17\4\0\1\133\46\0\1\55\32\0\1\55"+
    "\14\0\1\62\7\0\1\63\2\0\1\64\2\0\1\65"+
    "\14\0\1\62\7\0\1\63\2\0\1\64\2\0\1\65"+
    "\21\0\1\70\11\0\1\71\20\0\1\70\11\0\1\71"+
    "\41\0\1\73\31\0\1\73\34\0\1\75\31\0\1\75"+
    "\14\0\1\77\32\0\1\77\37\0\1\102\13\0\1\103"+
    "\16\0\1\102\12\0\1\103\10\0\1\107\15\0\1\110"+
    "\5\0\1\111\6\0\1\107\15\0\1\110\4\0\1\111"+
    "\33\0\1\113\31\0\1\113\11\0\1\116\23\0\1\117"+
    "\6\0\1\116\22\0\1\117\14\0\1\122\20\0\1\123"+
    "\11\0\1\122\17\0\1\123\32\0\1\126\1\127\30\0"+
    "\1\126\1\127\10\0\1\131\32\0\1\131\37\0\1\133"+
    "\32\0\1\133\22\0\1\53\1\0\2\53\1\134\30\53"+
    "\2\0\30\53\4\0\1\53\17\17\1\135\10\17\2\0"+
    "\1\17\17\0\1\136\33\0\1\136\32\0\1\136\13\0"+
    "\1\53\22\17\1\137\5\17\2\0\1\17\21\0\1\140"+
    "\11\0\1\53\23\17\1\141\4\17\2\0\1\17\22\0"+
    "\1\142\10\0\1\53\30\17\2\0\1\143\33\0\1\53"+
    "\24\17\1\144\3\17\2\0\1\17\23\0\1\145\32\0"+
    "\1\140\31\0\1\140\35\0\1\142\31\0\1\142\43\0"+
    "\1\146\60\0\1\145\31\0\1\145\7\0\1\53\5\17"+
    "\1\147\11\17\1\150\10\17\2\0\1\17\5\0\1\151"+
    "\11\0\1\152\13\0\1\53\2\17\1\153\25\17\2\0"+
    "\1\17\2\0\1\154\36\0\1\151\11\0\1\152\20\0"+
    "\1\151\11\0\1\152\16\0\1\154\32\0\1\154\30\0"+
    "\1\53\30\17\2\0\1\155\66\0\1\156\33\0\1\53"+
    "\13\17\1\157\14\17\2\0\1\17\13\0\1\160\33\0"+
    "\1\160\32\0\1\160\17\0\1\53\6\17\1\161\21\17"+
    "\2\0\1\17\6\0\1\162\33\0\1\162\32\0\1\162"+
    "\24\0\1\53\15\17\1\163\4\17\1\164\5\17\2\0"+
    "\1\17\15\0\1\165\3\0\1\166\11\0\1\53\15\17"+
    "\1\167\12\17\2\0\1\17\15\0\1\170\33\0\1\165"+
    "\4\0\1\166\25\0\1\165\3\0\1\166\27\0\1\170"+
    "\32\0\1\170\15\0\1\53\14\17\1\171\13\17\2\0"+
    "\1\17\14\0\1\172\16\0\1\53\23\17\1\173\4\17"+
    "\2\0\1\17\22\0\1\174\10\0\1\53\14\17\1\175"+
    "\13\17\2\0\1\17\14\0\1\176\33\0\1\172\32\0"+
    "\1\172\42\0\1\174\31\0\1\174\25\0\1\176\32\0"+
    "\1\176\16\0\1\53\7\17\1\177\20\17\2\0\1\17"+
    "\7\0\1\200\33\0\1\200\32\0\1\200\23\0\1\53"+
    "\21\17\1\201\6\17\2\0\1\17\20\0\1\202\12\0"+
    "\1\53\1\17\1\203\26\17\2\0\1\17\1\0\1\204"+
    "\53\0\1\202\31\0\1\202\14\0\1\204\32\0\1\204"+
    "\31\0\1\53\5\17\1\205\1\206\21\17\2\0\1\17"+
    "\5\0\1\207\1\210\24\0\1\53\30\17\2\0\1\211"+
    "\41\0\1\207\1\210\31\0\1\207\1\210\57\0\1\212"+
    "\33\0\1\53\17\17\1\213\10\17\2\0\1\17\17\0"+
    "\1\214\13\0\1\53\1\17\1\215\26\17\2\0\1\17"+
    "\1\0\1\216\51\0\1\214\32\0\1\214\15\0\1\216"+
    "\32\0\1\216\31\0\1\53\21\17\1\217\6\17\2\0"+
    "\1\17\20\0\1\220\34\0\1\220\31\0\1\220\12\0"+
    "\1\53\1\221\27\17\2\0\1\17\1\222\33\0\1\222"+
    "\32\0\1\222\31\0\1\223\67\0\1\53\13\17\1\224"+
    "\14\17\2\0\1\17\13\0\1\225\33\0\1\225\32\0"+
    "\1\225\17\0\1\53\4\17\1\211\23\17\2\0\1\17"+
    "\4\0\1\212\33\0\1\212\32\0\1\212\26\0\1\53"+
    "\27\17\1\226\2\0\1\17\26\0\1\227\34\0\1\227"+
    "\31\0\1\227\4\0\1\53\1\230\2\17\1\231\15\17"+
    "\1\232\1\233\5\17\2\0\1\17\1\234\2\0\1\235"+
    "\14\0\1\236\1\237\11\0\1\53\15\17\1\240\12\17"+
    "\2\0\1\17\15\0\1\241\33\0\1\241\32\0\1\241"+
    "\16\0\1\234\2\0\1\235\15\0\1\236\1\237\10\0"+
    "\1\234\2\0\1\235\14\0\1\236\1\237\11\0\1\53"+
    "\4\17\1\242\23\17\2\0\1\17\4\0\1\243\26\0"+
    "\1\53\16\17\1\244\11\17\2\0\1\17\16\0\1\245"+
    "\21\0\1\243\32\0\1\243\45\0\1\245\32\0\1\245"+
    "\14\0\1\53\23\17\1\246\4\17\2\0\1\247\22\0"+
    "\1\250\34\0\1\250\6\0\1\251\22\0\1\250\10\0"+
    "\1\53\2\17\1\252\10\17\1\24\14\17\2\0\1\17"+
    "\2\0\1\253\10\0\1\42\22\0\1\253\10\0\1\42"+
    "\21\0\1\253\10\0\1\42\17\0\1\53\13\17\1\254"+
    "\14\17\2\0\1\17\13\0\1\255\33\0\1\255\32\0"+
    "\1\255\17\0\1\53\30\17\2\0\1\256\66\0\1\257"+
    "\33\0\1\53\10\17\1\260\17\17\2\0\1\17\10\0"+
    "\1\261\22\0\1\53\2\17\1\262\25\17\2\0\1\17"+
    "\2\0\1\263\41\0\1\261\32\0\1\261\25\0\1\263"+
    "\32\0\1\263\30\0\1\53\10\17\1\264\17\17\2\0"+
    "\1\17\10\0\1\265\33\0\1\265\32\0\1\265\22\0"+
    "\1\53\4\17\1\266\23\17\2\0\1\17\4\0\1\267"+
    "\33\0\1\267\32\0\1\267\26\0\1\53\10\17\1\270"+
    "\17\17\2\0\1\17\10\0\1\271\33\0\1\271\32\0"+
    "\1\271\22\0\1\53\1\17\1\272\26\17\2\0\1\17"+
    "\1\0\1\273\33\0\1\273\32\0\1\273\31\0\1\53"+
    "\4\17\1\274\23\17\2\0\1\17\4\0\1\275\33\0"+
    "\1\275\32\0\1\275\26\0\1\53\23\17\1\276\4\17"+
    "\2\0\1\17\22\0\1\277\34\0\1\277\31\0\1\277"+
    "\10\0\1\53\13\17\1\300\14\17\2\0\1\17\13\0"+
    "\1\301\33\0\1\301\32\0\1\301\17\0\1\302\30\17"+
    "\2\0\1\17\33\0\1\53\10\17\1\303\17\17\2\0"+
    "\1\17\10\0\1\304\22\0\1\305\77\0\1\304\32\0"+
    "\1\304\22\0\1\53\15\17\1\306\12\17\2\0\1\17"+
    "\15\0\1\307\33\0\1\307\32\0\1\307\15\0\1\53"+
    "\26\17\1\262\1\17\2\0\1\17\25\0\1\263\34\0"+
    "\1\263\31\0\1\263\5\0\1\53\11\17\1\310\16\17"+
    "\2\0\1\17\11\0\1\311\33\0\1\311\32\0\1\311"+
    "\21\0\1\53\15\17\1\312\12\17\2\0\1\17\15\0"+
    "\1\313\33\0\1\313\32\0\1\313\15\0\1\53\21\17"+
    "\1\314\6\17\2\0\1\17\20\0\1\315\34\0\1\315"+
    "\31\0\1\315\11\0\1\223\32\0\1\15\34\0\1\53"+
    "\10\17\1\316\17\17\2\0\1\17\10\0\1\317\33\0"+
    "\1\317\32\0\1\317\22\0\1\320\30\17\2\0\1\17"+
    "\33\0\1\321\66\0\1\53\24\17\1\322\3\17\2\0"+
    "\1\17\23\0\1\323\7\0\1\53\4\17\1\324\11\17"+
    "\1\325\11\17\2\0\1\17\4\0\1\326\11\0\1\327"+
    "\14\0\1\53\4\17\1\330\23\17\2\0\1\17\4\0"+
    "\1\331\26\0\1\53\4\17\1\332\23\17\2\0\1\17"+
    "\4\0\1\333\53\0\1\323\31\0\1\323\14\0\1\326"+
    "\11\0\1\327\20\0\1\326\11\0\1\327\21\0\1\331"+
    "\32\0\1\331\33\0\1\333\32\0\1\333\26\0\1\53"+
    "\23\17\1\334\4\17\2\0\1\17\22\0\1\335\34\0"+
    "\1\335\31\0\1\335\10\0\1\53\15\17\1\336\12\17"+
    "\2\0\1\17\15\0\1\337\33\0\1\337\32\0\1\337"+
    "\15\0\1\53\22\17\1\340\5\17\2\0\1\17\21\0"+
    "\1\341\34\0\1\341\31\0\1\341\11\0\1\53\27\17"+
    "\1\342\2\0\1\17\26\0\1\343\4\0\1\53\3\17"+
    "\1\344\24\17\2\0\1\17\3\0\1\345\57\0\1\343"+
    "\31\0\1\343\10\0\1\345\32\0\1\345\27\0\1\53"+
    "\13\17\1\346\14\17\2\0\1\17\13\0\1\347\33\0"+
    "\1\347\32\0\1\347\17\0\1\53\30\17\2\0\1\350"+
    "\66\0\1\351\33\0\1\53\1\230\2\17\1\352\15\17"+
    "\1\353\6\17\2\0\1\17\1\234\2\0\1\354\14\0"+
    "\1\355\13\0\1\234\2\0\1\354\15\0\1\355\11\0"+
    "\1\234\2\0\1\354\14\0\1\355\12\0\1\53\22\17"+
    "\1\356\5\17\2\0\1\17\21\0\1\357\34\0\1\357"+
    "\31\0\1\357\11\0\1\360\30\17\2\0\1\17\33\0"+
    "\1\361\66\0\1\53\2\17\1\362\25\17\2\0\1\17"+
    "\2\0\1\363\33\0\1\363\32\0\1\363\30\0\1\53"+
    "\3\17\1\364\24\17\2\0\1\17\3\0\1\365\33\0"+
    "\1\365\32\0\1\365\27\0\1\53\5\17\1\300\22\17"+
    "\2\0\1\17\5\0\1\301\33\0\1\301\32\0\1\301"+
    "\25\0\1\53\4\17\1\366\23\17\2\0\1\17\4\0"+
    "\1\367\33\0\1\367\32\0\1\367\26\0\1\53\21\17"+
    "\1\370\6\17\2\0\1\17\20\0\1\371\34\0\1\371"+
    "\31\0\1\371\12\0\1\53\10\17\1\372\17\17\2\0"+
    "\1\17\10\0\1\373\33\0\1\373\32\0\1\373\22\0"+
    "\1\53\10\17\1\374\17\17\2\0\1\17\10\0\1\375"+
    "\33\0\1\375\32\0\1\375\16\0\1\302\1\0\2\302"+
    "\1\376\30\302\2\0\30\302\4\0\1\53\16\17\1\377"+
    "\11\17\2\0\1\17\16\0\1\u0100\33\0\1\u0100\32\0"+
    "\1\u0100\10\0\1\305\1\0\2\305\1\u0101\30\305\2\0"+
    "\30\305\4\0\1\53\24\17\1\u0102\3\17\2\0\1\17"+
    "\23\0\1\u0103\34\0\1\u0103\31\0\1\u0103\7\0\1\53"+
    "\4\17\1\u0104\23\17\2\0\1\17\4\0\1\u0105\33\0"+
    "\1\u0105\32\0\1\u0105\26\0\1\53\10\17\1\u0106\17\17"+
    "\2\0\1\17\10\0\1\u0107\33\0\1\u0107\32\0\1\u0107"+
    "\22\0\1\u0108\30\17\2\0\1\17\33\0\1\u0109\66\0"+
    "\1\53\2\17\1\u010a\25\17\2\0\1\17\2\0\1\u010b"+
    "\33\0\1\u010b\32\0\1\u010b\24\0\1\320\1\0\2\320"+
    "\1\u010c\30\320\2\0\30\320\1\321\1\0\2\321\1\u010d"+
    "\30\321\2\0\30\321\4\0\1\53\23\17\1\u010e\4\17"+
    "\2\0\1\17\22\0\1\u010f\34\0\1\u010f\31\0\1\u010f"+
    "\10\0\1\53\23\17\1\u0110\4\17\2\0\1\17\22\0"+
    "\1\u0111\10\0\1\53\2\17\1\u0112\25\17\2\0\1\17"+
    "\2\0\1\u0113\54\0\1\u0111\31\0\1\u0111\13\0\1\u0113"+
    "\32\0\1\u0113\30\0\1\53\5\17\1\205\22\17\2\0"+
    "\1\17\5\0\1\207\33\0\1\207\32\0\1\207\25\0"+
    "\1\53\2\17\1\u0114\25\17\2\0\1\17\2\0\1\u0115"+
    "\33\0\1\u0115\32\0\1\u0115\30\0\1\53\21\17\1\141"+
    "\6\17\2\0\1\17\20\0\1\142\34\0\1\142\31\0"+
    "\1\142\12\0\1\53\3\17\1\u010a\24\17\2\0\1\17"+
    "\3\0\1\u010b\33\0\1\u010b\32\0\1\u010b\27\0\1\53"+
    "\10\17\1\u0116\17\17\2\0\1\17\10\0\1\u0117\33\0"+
    "\1\u0117\32\0\1\u0117\22\0\1\53\17\17\1\u0118\10\17"+
    "\2\0\1\17\17\0\1\u0119\33\0\1\u0119\32\0\1\u0119"+
    "\13\0\1\53\1\u011a\27\17\2\0\1\17\1\u011b\33\0"+
    "\1\u011b\32\0\1\u011b\32\0\1\53\30\17\2\0\1\u011c"+
    "\66\0\1\u011d\33\0\1\53\4\17\1\u011e\10\17\1\306"+
    "\12\17\2\0\1\17\4\0\1\u011f\10\0\1\307\22\0"+
    "\1\u011f\10\0\1\307\21\0\1\u011f\10\0\1\307\15\0"+
    "\1\53\16\17\1\325\11\17\2\0\1\17\16\0\1\327"+
    "\14\0\1\53\4\17\1\u0120\23\17\2\0\1\17\4\0"+
    "\1\u0121\45\0\1\327\32\0\1\327\21\0\1\u0121\32\0"+
    "\1\u0121\26\0\1\53\23\17\1\u0122\4\17\2\0\1\17"+
    "\22\0\1\u0123\34\0\1\u0123\31\0\1\u0123\4\0\1\360"+
    "\1\0\2\360\1\u0124\30\360\2\0\30\360\1\361\1\0"+
    "\2\361\1\u0125\30\361\2\0\30\361\4\0\1\53\10\17"+
    "\1\u0126\17\17\2\0\1\17\10\0\1\u0127\33\0\1\u0127"+
    "\32\0\1\u0127\22\0\1\53\30\17\2\0\1\u0128\66\0"+
    "\1\u0129\33\0\1\53\21\17\1\u012a\6\17\2\0\1\17"+
    "\20\0\1\u012b\34\0\1\u012b\31\0\1\u012b\12\0\1\53"+
    "\30\17\2\0\1\u012c\66\0\1\u012d\33\0\1\53\23\17"+
    "\1\u012e\4\17\2\0\1\17\22\0\1\u012f\34\0\1\u012f"+
    "\31\0\1\u012f\10\0\1\53\2\17\1\u0130\25\17\2\0"+
    "\1\17\2\0\1\u0131\33\0\1\u0131\32\0\1\u0131\27\0"+
    "\1\u0132\67\0\1\53\15\17\1\226\12\17\2\0\1\17"+
    "\15\0\1\227\33\0\1\227\32\0\1\227\14\0\1\u0133"+
    "\67\0\1\53\14\17\1\u0134\13\17\2\0\1\17\14\0"+
    "\1\u0135\33\0\1\u0135\32\0\1\u0135\16\0\1\53\2\17"+
    "\1\u0136\25\17\2\0\1\17\2\0\1\u0137\33\0\1\u0137"+
    "\32\0\1\u0137\30\0\1\53\15\17\1\u0138\12\17\2\0"+
    "\1\17\15\0\1\u0139\33\0\1\u0139\32\0\1\u0139\11\0"+
    "\1\u0108\1\0\2\u0108\1\u013a\30\u0108\2\0\30\u0108\1\u0109"+
    "\1\0\2\u0109\1\u013b\30\u0109\2\0\30\u0109\4\0\1\53"+
    "\1\u013c\27\17\2\0\1\17\1\u013d\33\0\1\u013d\32\0"+
    "\1\u013d\31\0\1\u013e\66\0\1\u013f\67\0\1\53\7\17"+
    "\1\u0140\20\17\2\0\1\17\7\0\1\u0141\33\0\1\u0141"+
    "\32\0\1\u0141\23\0\1\53\1\u0142\27\17\2\0\1\17"+
    "\1\u0143\33\0\1\u0143\32\0\1\u0143\32\0\1\53\23\17"+
    "\1\246\4\17\2\0\1\17\22\0\1\250\34\0\1\250"+
    "\31\0\1\250\10\0\1\53\23\17\1\u0144\4\17\2\0"+
    "\1\17\22\0\1\u0145\34\0\1\u0145\31\0\1\u0145\10\0"+
    "\1\53\23\17\1\u0146\4\17\2\0\1\17\22\0\1\u0147"+
    "\34\0\1\u0147\31\0\1\u0147\10\0\1\53\4\17\1\u0148"+
    "\23\17\2\0\1\17\4\0\1\u0149\33\0\1\u0149\32\0"+
    "\1\u0149\26\0\1\53\23\17\1\u014a\4\17\2\0\1\17"+
    "\22\0\1\u014b\34\0\1\u014b\31\0\1\u014b\10\0\1\53"+
    "\1\230\20\17\1\232\6\17\2\0\1\17\1\234\17\0"+
    "\1\236\13\0\1\234\20\0\1\236\11\0\1\234\17\0"+
    "\1\236\12\0\1\53\24\17\1\121\3\17\2\0\1\17"+
    "\23\0\1\123\34\0\1\123\31\0\1\123\7\0\1\53"+
    "\5\17\1\u014c\22\17\2\0\1\17\5\0\1\u014d\33\0"+
    "\1\u014d\32\0\1\u014d\25\0\1\53\21\17\1\u014e\6\17"+
    "\2\0\1\17\20\0\1\u014f\34\0\1\u014f\31\0\1\u014f"+
    "\11\0\1\u0150\66\0\1\u0151\67\0\1\53\17\17\1\u0152"+
    "\10\17\2\0\1\17\17\0\1\u0153\33\0\1\u0153\32\0"+
    "\1\u0153\13\0\1\53\4\17\1\u0154\23\17\2\0\1\17"+
    "\4\0\1\u0155\33\0\1\u0155\32\0\1\u0155\26\0\1\u0108"+
    "\30\17\2\0\1\u0156\33\0\1\u0109\32\0\1\u0157\33\0"+
    "\1\53\1\230\27\17\2\0\1\17\1\234\33\0\1\234"+
    "\32\0\1\234\32\0\1\53\10\17\1\u0158\17\17\2\0"+
    "\1\17\10\0\1\u0159\33\0\1\u0159\32\0\1\u0159\22\0"+
    "\1\53\1\u015a\27\17\2\0\1\17\1\u015b\33\0\1\u015b"+
    "\32\0\1\u015b\31\0\1\u0132\32\0\1\u015c\33\0\1\u0133"+
    "\32\0\1\u015d\34\0\1\53\1\17\1\u015e\26\17\2\0"+
    "\1\17\1\0\1\u015f\33\0\1\u015f\32\0\1\u015f\31\0"+
    "\1\53\23\17\1\u0160\4\17\2\0\1\17\22\0\1\u0161"+
    "\34\0\1\u0161\31\0\1\u0161\10\0\1\53\6\17\1\u0162"+
    "\21\17\2\0\1\17\6\0\1\u0163\33\0\1\u0163\32\0"+
    "\1\u0163\23\0\1\u0164\66\0\1\u0165\67\0\1\53\15\17"+
    "\1\u0166\12\17\2\0\1\17\15\0\1\u0167\33\0\1\u0167"+
    "\32\0\1\u0167\14\0\1\u013e\32\0\1\u0168\33\0\1\u013f"+
    "\32\0\1\u0169\34\0\1\u016a\30\17\2\0\1\17\33\0"+
    "\1\u016b\66\0\1\53\2\17\1\u016c\25\17\2\0\1\17"+
    "\2\0\1\u016d\33\0\1\u016d\32\0\1\u016d\30\0\1\53"+
    "\10\17\1\u016e\17\17\2\0\1\17\10\0\1\u016f\33\0"+
    "\1\u016f\32\0\1\u016f\22\0\1\53\30\17\2\0\1\247"+
    "\66\0\1\251\33\0\1\u0170\30\17\2\0\1\17\33\0"+
    "\1\u0171\66\0\1\53\4\17\1\u0172\23\17\2\0\1\17"+
    "\4\0\1\u0173\33\0\1\u0173\32\0\1\u0173\26\0\1\302"+
    "\30\17\2\0\1\u0174\33\0\1\305\32\0\1\u0175\33\0"+
    "\1\53\27\17\1\u0176\2\0\1\17\26\0\1\u0177\34\0"+
    "\1\u0177\31\0\1\u0177\3\0\1\u0150\32\0\1\u0178\33\0"+
    "\1\u0151\32\0\1\u0179\34\0\1\53\1\u017a\27\17\2\0"+
    "\1\17\1\u017b\33\0\1\u017b\32\0\1\u017b\32\0\1\53"+
    "\15\17\1\u017c\12\17\2\0\1\17\15\0\1\u017d\33\0"+
    "\1\u017d\32\0\1\u017d\15\0\1\53\27\17\1\34\2\0"+
    "\1\17\26\0\1\52\34\0\1\52\31\0\1\52\4\0"+
    "\1\53\16\17\1\u017e\11\17\2\0\1\17\16\0\1\u017f"+
    "\33\0\1\u017f\32\0\1\u017f\14\0\1\53\23\17\1\u0180"+
    "\4\17\2\0\1\17\22\0\1\u0181\34\0\1\u0181\31\0"+
    "\1\u0181\4\0\35\u0182\1\0\31\u0182\4\0\1\53\4\17"+
    "\1\221\23\17\2\0\1\17\4\0\1\222\33\0\1\222"+
    "\32\0\1\222\26\0\1\u0183\30\17\2\0\1\17\33\0"+
    "\1\u0184\66\0\1\u0185\30\17\2\0\1\17\33\0\1\u0186"+
    "\65\0\1\u0164\32\0\1\u0187\33\0\1\u0165\32\0\1\u0188"+
    "\34\0\1\53\23\17\1\u0189\4\17\2\0\1\17\22\0"+
    "\1\u018a\34\0\1\u018a\31\0\1\u018a\4\0\35\u018b\1\0"+
    "\31\u018b\1\u016a\1\0\2\u016a\1\u018c\30\u016a\2\0\30\u016a"+
    "\1\u016b\1\0\2\u016b\1\u018d\30\u016b\2\0\30\u016b\4\0"+
    "\1\53\7\17\1\u018e\20\17\2\0\1\17\7\0\1\u018f"+
    "\33\0\1\u018f\32\0\1\u018f\23\0\1\53\16\17\1\u0190"+
    "\11\17\2\0\1\17\16\0\1\u0191\33\0\1\u0191\32\0"+
    "\1\u0191\10\0\1\u0170\1\0\2\u0170\1\u0192\30\u0170\2\0"+
    "\30\u0170\1\u0171\1\0\2\u0171\1\u0193\30\u0171\2\0\30\u0171"+
    "\4\0\1\u0194\30\17\2\0\1\17\33\0\1\u0195\66\0"+
    "\1\53\17\17\1\u0196\10\17\2\0\1\17\17\0\1\u0197"+
    "\33\0\1\u0197\32\0\1\u0197\13\0\1\u0198\30\17\2\0"+
    "\1\17\33\0\1\u0199\62\0\35\u019a\1\0\31\u019a\4\0"+
    "\1\53\13\17\1\u019b\14\17\2\0\1\17\13\0\1\u019c"+
    "\33\0\1\u019c\32\0\1\u019c\17\0\1\53\23\17\1\u019d"+
    "\4\17\2\0\1\17\22\0\1\u019e\34\0\1\u019e\31\0"+
    "\1\u019e\10\0\1\53\15\17\1\u019f\12\17\2\0\1\17"+
    "\15\0\1\u01a0\33\0\1\u01a0\32\0\1\u01a0\15\0\1\53"+
    "\10\17\1\u01a1\17\17\2\0\1\17\10\0\1\u01a2\33\0"+
    "\1\u01a2\32\0\1\u01a2\16\0\35\u0182\1\u01a3\31\u0182\1\u0183"+
    "\1\0\2\u0183\1\u01a4\30\u0183\2\0\30\u0183\1\u0184\1\0"+
    "\2\u0184\1\u01a5\30\u0184\2\0\30\u0184\1\u0185\1\0\2\u0185"+
    "\1\u01a6\30\u0185\2\0\30\u0185\1\u0186\1\0\2\u0186\1\u01a7"+
    "\30\u0186\2\0\30\u0186\35\u01a8\1\0\31\u01a8\4\0\1\u01a9"+
    "\30\17\2\0\1\17\33\0\1\u01aa\62\0\35\u018b\1\u01ab"+
    "\31\u018b\3\0\1\u01ac\66\0\1\u01ad\67\0\1\53\4\17"+
    "\1\u01ae\23\17\2\0\1\17\4\0\1\u01af\33\0\1\u01af"+
    "\32\0\1\u01af\26\0\1\53\15\17\1\u0176\12\17\2\0"+
    "\1\17\15\0\1\u0177\33\0\1\u0177\32\0\1\u0177\14\0"+
    "\1\u01b0\66\0\1\u01b1\63\0\1\u0194\1\0\2\u0194\1\u01b2"+
    "\30\u0194\2\0\30\u0194\1\u0195\1\0\2\u0195\1\u01b3\30\u0195"+
    "\2\0\30\u0195\4\0\1\53\1\u01b4\27\17\2\0\1\17"+
    "\1\u01b5\33\0\1\u01b5\32\0\1\u01b5\26\0\1\u0198\1\0"+
    "\2\u0198\1\u01b6\30\u0198\2\0\30\u0198\1\u0199\1\0\2\u0199"+
    "\1\u01b7\30\u0199\2\0\30\u0199\35\u019a\1\u01b8\31\u019a\4\0"+
    "\1\53\10\17\1\57\17\17\2\0\1\17\10\0\1\63"+
    "\33\0\1\63\32\0\1\63\22\0\1\53\10\17\1\u01b9"+
    "\17\17\2\0\1\17\10\0\1\u01ba\33\0\1\u01ba\32\0"+
    "\1\u01ba\22\0\1\u01bb\30\17\2\0\1\17\33\0\1\u01bc"+
    "\66\0\1\53\16\17\1\u01bd\11\17\2\0\1\17\16\0"+
    "\1\u01be\33\0\1\u01be\32\0\1\u01be\12\0\1\u01bf\67\0"+
    "\1\u01c0\66\0\1\u01c1\66\0\1\u01c2\66\0\1\u01c3\63\0"+
    "\35\u01a8\1\u01c4\31\u01a8\1\u01a9\1\0\2\u01a9\1\u01c5\30\u01a9"+
    "\2\0\30\u01a9\1\u01aa\1\0\2\u01aa\1\u01c6\30\u01aa\2\0"+
    "\30\u01aa\2\0\1\u01c7\67\0\1\u01ac\32\0\1\u01c8\33\0"+
    "\1\u01ad\32\0\1\u01c9\34\0\1\53\3\17\1\u01ca\24\17"+
    "\2\0\1\17\3\0\1\u01cb\33\0\1\u01cb\32\0\1\u01cb"+
    "\26\0\1\u01b0\32\0\1\u01cc\33\0\1\u01b1\32\0\1\u01cd"+
    "\33\0\1\u01ce\66\0\1\u01cf\67\0\1\53\21\17\1\u01d0"+
    "\6\17\2\0\1\17\20\0\1\u01d1\34\0\1\u01d1\31\0"+
    "\1\u01d1\11\0\1\u01d2\66\0\1\u01d3\65\0\1\u01d4\70\0"+
    "\1\53\23\17\1\u01d5\4\17\2\0\1\17\22\0\1\u01d6"+
    "\34\0\1\u01d6\31\0\1\u01d6\4\0\1\u01bb\1\0\2\u01bb"+
    "\1\u01d7\30\u01bb\2\0\30\u01bb\1\u01bc\1\0\2\u01bc\1\u01d8"+
    "\30\u01bc\2\0\30\u01bc\4\0\1\53\15\17\1\u0146\12\17"+
    "\2\0\1\17\15\0\1\u0147\33\0\1\u0147\32\0\1\u0147"+
    "\31\0\1\u01d9\32\0\1\u01d9\16\0\1\u01c0\32\0\1\u01da"+
    "\33\0\1\u01c1\32\0\1\u01db\33\0\1\u01c2\32\0\1\u01dc"+
    "\33\0\1\u01c3\32\0\1\u01dd\32\0\1\u01de\67\0\1\u01df"+
    "\66\0\1\u01e0\103\0\1\u01e1\32\0\1\u01e1\13\0\35\u01e2"+
    "\1\0\31\u01e2\4\0\1\u01e3\30\17\2\0\1\17\33\0"+
    "\1\u01e4\62\0\35\u01e5\1\0\31\u01e5\3\0\1\u01ce\32\0"+
    "\1\u01e6\33\0\1\u01cf\32\0\1\u01e7\34\0\1\53\23\17"+
    "\1\205\4\17\2\0\1\17\22\0\1\207\34\0\1\207"+
    "\31\0\1\207\7\0\1\u01d2\32\0\1\u01e8\33\0\1\u01d3"+
    "\32\0\1\u01e9\50\0\1\u01ea\32\0\1\u01ea\17\0\1\53"+
    "\27\17\1\u0189\2\0\1\17\26\0\1\u018a\34\0\1\u018a"+
    "\31\0\1\u018a\3\0\1\u01eb\66\0\1\u01ec\102\0\1\u01ed"+
    "\32\0\1\u01ed\14\0\35\u01ee\1\0\31\u01ee\35\u01ef\1\0"+
    "\31\u01ef\20\0\1\u01f0\32\0\1\u01f0\16\0\1\u01df\32\0"+
    "\1\u01f1\33\0\1\u01e0\32\0\1\u01f2\47\0\1\u01f3\32\0"+
    "\1\u01f3\14\0\35\u01e2\1\u01f4\31\u01e2\1\u01e3\1\0\2\u01e3"+
    "\1\u01f5\30\u01e3\2\0\30\u01e3\1\u01e4\1\0\2\u01e4\1\u01f6"+
    "\30\u01e4\2\0\30\u01e4\35\u01e5\1\u01f7\31\u01e5\35\u01f8\1\0"+
    "\31\u01f8\35\u01f9\1\0\31\u01f9\17\0\1\u01fa\32\0\1\u01fa"+
    "\17\0\1\u01eb\32\0\1\u01fb\33\0\1\u01ec\32\0\1\u01fc"+
    "\52\0\1\u01fd\32\0\1\u01fd\11\0\35\u01ee\1\u01fe\31\u01ee"+
    "\35\u01ef\1\u01ff\31\u01ef\17\0\1\u0200\32\0\1\u0200\14\0"+
    "\35\u0201\1\0\31\u0201\22\0\1\u0202\32\0\1\u0202\13\0"+
    "\1\u0203\67\0\1\u0204\66\0\1\u0205\65\0\1\u0206\64\0"+
    "\35\u01f8\1\u0207\31\u01f8\35\u01f9\1\u0208\31\u01f9\22\0\1\u0209"+
    "\32\0\1\u0209\11\0\35\u020a\1\0\31\u020a\36\0\1\u020b"+
    "\32\0\1\u020c\66\0\1\u020d\106\0\1\u020e\32\0\1\u020e"+
    "\11\0\35\u0201\1\u020f\31\u0201\36\0\1\u0210\50\0\1\u0211"+
    "\32\0\1\u0211\16\0\1\u0204\32\0\1\u0212\33\0\1\u0205"+
    "\32\0\1\u0213\50\0\1\u0214\32\0\1\u0214\15\0\1\u0215"+
    "\66\0\1\u0216\122\0\1\u0217\30\0\35\u020a\1\u0218\31\u020a"+
    "\20\0\1\u0219\32\0\1\u0219\33\0\1\u021a\32\0\1\u021a"+
    "\51\0\1\u021b\32\0\1\u021c\103\0\1\u021d\32\0\1\u021d"+
    "\14\0\35\u021e\1\0\31\u021e\17\0\1\u021f\32\0\1\u021f"+
    "\34\0\1\u0220\32\0\1\u0220\33\0\1\u0221\32\0\1\u0221"+
    "\15\0\1\u0222\103\0\1\u0223\32\0\1\u0223\33\0\1\u0224"+
    "\32\0\1\u0224\34\0\1\u0225\32\0\1\u0225\35\0\1\u0226"+
    "\32\0\1\u0226\11\0\35\u021e\1\u0227\31\u021e\22\0\1\u0228"+
    "\32\0\1\u0228\30\0\1\u0229\32\0\1\u0229\33\0\1\u022a"+
    "\32\0\1\u022a\34\0\1\u022b\32\0\1\u022b\35\0\1\u022c"+
    "\32\0\1\u022c\33\0\1\u022d\32\0\1\u022d\30\0\1\u022e"+
    "\32\0\1\u022e\52\0\1\u022f\32\0\1\u0230\122\0\1\u0231"+
    "\52\0\1\u0232\32\0\1\u0232\33\0\1\u0233\32\0\1\u0233"+
    "\30\0\1\u0234\32\0\1\u0234\52\0\1\u0235\66\0\1\u0236"+
    "\52\0\1\u0237\32\0\1\u0237\31\0\1\u0238\32\0\1\u0238"+
    "\51\0\1\u0239\66\0\1\u023a\52\0\1\u023b\32\0\1\u023b"+
    "\47\0\1\u023c\47\0\1\u023d\32\0\1\u023d\52\0\1\u023e"+
    "\52\0\1\u023f\32\0\1\u023f\47\0\1\u0240\30\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[30195];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\1\0\1\11\2\1\10\0\1\11\u014e\0\1\1\13\0"+
    "\1\1\17\0\1\1\16\0\1\1\100\0\1\1\3\0"+
    "\1\1\15\0\1\1\1\0\1\1\11\0\1\1\1\0"+
    "\1\1\10\0\1\1\11\0\1\1\17\0\1\11\4\0"+
    "\1\11\1\0\1\1\4\0\1\11\3\0\1\11\23\0"+
    "\1\11\1\0\1\11\3\0\2\11\2\0\2\11\1\0"+
    "\1\11\1\0\1\11\1\0\1\11";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[576];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S220_HtmlDebugRenderer() { }
	
	private String getTitle(AnnotationEntity entity) {
		
		String title = entity.getEntity().toString();
		
		if(entity.getValue().length() > 1)
			title += ":" + entity.getValue();
		
		return title;
	}
	
	private String getTitle(Reference entity) {
		
		LinkolnReference lr = getLinkolnDocument().getLinkolnReferenceFromId(entity.getId());
		
		return lr.toString(true, true);
	}

	private String getValues(Reference ref) {
		
		String title = "";
		
		for(AnnotationEntity entity : ref.getRelatedEntities()) {
			
			title += entity.getEntity().toString();
		
			if(entity.getValue().length() > 1)
				title += ":" + entity.getValue();
			
			title += " ";
		}
		
		return title.trim();
	}



  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S220_HtmlDebugRenderer(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
            }
          // fall through
          case 17: break;
          case 2:
            { addText("<strong>" + yytext() + "</strong>");
            }
          // fall through
          case 18: break;
          case 3:
            { 
            }
          // fall through
          case 19: break;
          case 4:
            { AnnotationEntity ref = retrieveEntity();
	
	LinkolnReference lr = getLinkolnDocument().getLinkolnReferenceFromId(ref.getId());
	
	String url = "";
	
	for(Identifier identifier : lr.getIdentifiers()) {
			
		if(identifier.getUrl() != null && identifier.getUrl().trim().length() > 0) {
			
			url = identifier.getUrl();
			break;
		}
	}
		
	if(url.equals("")) {
		
		addText("<font color=\"blue\" title=\"" + lr.toString(true, true) + "\" " + lr.toString(true, true) + ">" + ref.getText() + "</font>");
			
	} else {
		
		addText("<a href=\"" + url + "\" title=\"" + lr.toString(false, true) + "\" " + lr.toString(false, true) + ">" + ref.getText() + "</a>");
	}
            }
          // fall through
          case 20: break;
          case 5:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"lime\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 21: break;
          case 6:
            { /*
	AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"gray\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
	*/
	addText("<font color=\"gray\">" + Util.removeAllAnnotations(yytext()) + "</font>");
            }
          // fall through
          case 22: break;
          case 7:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"brown\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 23: break;
          case 8:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"orange\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 24: break;
          case 9:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"green\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 25: break;
          case 10:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"lightseagreen\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 26: break;
          case 11:
            { AnnotationEntity warning = retrieveEntity();
	
	addText("<font color=\"red\">" + warning.getText() + "</font>");
            }
          // fall through
          case 27: break;
          case 12:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"purple\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 28: break;
          case 13:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"crimson\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 29: break;
          case 14:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"hotpink\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 30: break;
          case 15:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"cadetblue\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 31: break;
          case 16:
            { AnnotationEntity entity = retrieveEntity();
	addText("<font color=\"indianred\" title=\"" + getTitle(entity) + "\">" + entity.getText() + "</font>");
            }
          // fall through
          case 32: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S220_HtmlDebugRenderer [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S220_HtmlDebugRenderer scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S220_HtmlDebugRenderer(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
